Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.gradle.api.invocation
Interface Gradle

    public interface Gradle

Represents an invocation of Gradle.

You can obtain a `Gradle` instance by calling `Project.getGradle()`.

Method Summary
`void` | `addBuildListener(BuildListener buildListener)` Adds a `BuildListener` to this Build instance.
`void` | `addListener(Object listener)` Adds the given listener to this build.
`ProjectEvaluationListener` | `addProjectEvaluationListener(ProjectEvaluationListener listener)` Adds a listener to this build, to receive notifications as projects are evaluated.
`void` | `afterProject(Closure closure)` Adds a closure to be called immediately after a project is evaluated.
`void` | `beforeProject(Closure closure)` Adds a closure to be called immediately before a project is evaluated.
`void` | `buildFinished(Closure closure)` Adds a closure to be called when the build is completed.
`void` | `buildStarted(Closure closure)` Adds a closure to be called when the build is started.
`Gradle` | `getGradle()` Returns this `Gradle` instance.
`File` | `getGradleHomeDir()` Deprecated. No replacement
`File` | `getGradleUserHomeDir()` Returns the Gradle user home directory.
`String` | `getGradleVersion()` Returns the current Gradle version.
`Gradle` | `getParent()` Returns the parent build of this build, if any.
`Project` | `getRootProject()` Returns the root project of this build.
`StartParameter` | `getStartParameter()` Returns the `StartParameter` used to start this build.
`TaskExecutionGraph` | `getTaskGraph()` Returns the `TaskExecutionGraph` for this build.
`void` | `projectsEvaluated(Closure closure)` Adds a closure to be called when all projects for the build have been evaluated.
`void` | `projectsLoaded(Closure closure)` Adds a closure to be called when the projects for the build have been created from the settings.
`void` | `removeListener(Object listener)` Removes the given listener from this build.
`void` | `removeProjectEvaluationListener(ProjectEvaluationListener listener)` Removes the given listener from this build.
`void` | `settingsEvaluated(Closure closure)` Adds a closure to be called when the build settings have been loaded and evaluated.
`void` | `useLogger(Object logger)` Uses the given object as a logger.

Method Detail

### getGradleVersion

    String getGradleVersion()

  Returns the current Gradle version.

  Returns:
    The Gradle version. Never returns null.

### getGradleUserHomeDir

    File getGradleUserHomeDir()

  Returns the Gradle user home directory. This directory is used to cache downloaded resources.

  Returns:
    The user home directory. Never returns null.

### getGradleHomeDir

    File getGradleHomeDir()

  Deprecated. No replacement

  Returns the Gradle home directory, if any. This directory is the directory containing the Gradle distribution executing this build.

  Returns:
    The home directory. May return null.

### getParent

    Gradle getParent()

  Returns the parent build of this build, if any.

  Returns:
    The parent build. May return null.

### getRootProject

    Project getRootProject()

  Returns the root project of this build.

  Returns:
    The root project. Never returns null.

### getTaskGraph

    TaskExecutionGraph getTaskGraph()

  Returns the `TaskExecutionGraph` for this build.

  Returns:
    The task graph. Never returns null.

### getStartParameter

    StartParameter getStartParameter()

  Returns the `StartParameter` used to start this build.

  Returns:
    The start parameter. Never returns null.

### addProjectEvaluationListener

    ProjectEvaluationListener addProjectEvaluationListener(ProjectEvaluationListener listener)

  Adds a listener to this build, to receive notifications as projects are evaluated.

  Parameters:
    `listener` - The listener to add. Does nothing if this listener has already been added.
  Returns:
    The added listener.

### removeProjectEvaluationListener

    void removeProjectEvaluationListener(ProjectEvaluationListener listener)

  Removes the given listener from this build.

  Parameters:
    `listener` - The listener to remove. Does nothing if this listener has not been added.

### beforeProject

    void beforeProject(Closure closure)

  Adds a closure to be called immediately before a project is evaluated. The project is passed to the closure as a parameter.

  Parameters:
    `closure` - The closure to execute.

### afterProject

    void afterProject(Closure closure)

  Adds a closure to be called immediately after a project is evaluated. The project is passed to the closure as the first parameter. The project evaluation failure, if any, is passed as the second parameter. Both parameters are optional.

  Parameters:
    `closure` - The closure to execute.

### buildStarted

    void buildStarted(Closure closure)

  Adds a closure to be called when the build is started. This `Gradle` instance is passed to the closure as the first parameter.

  Parameters:
    `closure` - The closure to execute.

### settingsEvaluated

    void settingsEvaluated(Closure closure)

  Adds a closure to be called when the build settings have been loaded and evaluated. The settings object is fully configured and is ready to use to load the build projects. The `Settings` object is passed to the closure as a parameter.

  Parameters:
    `closure` - The closure to execute.

### projectsLoaded

    void projectsLoaded(Closure closure)

  Adds a closure to be called when the projects for the build have been created from the settings. None of the projects have been evaluated. This `Gradle` instance is passed to the closure as a parameter.

  Parameters:
    `closure` - The closure to execute.

### projectsEvaluated

    void projectsEvaluated(Closure closure)

  Adds a closure to be called when all projects for the build have been evaluated. The project objects are fully configured and are ready to use to populate the task graph. This `Gradle` instance is passed to the closure as a parameter.

  Parameters:
    `closure` - The closure to execute.

### buildFinished

    void buildFinished(Closure closure)

  Adds a closure to be called when the build is completed. All selected tasks have been executed. A `BuildResult` instance is passed to the closure as a parameter.

  Parameters:
    `closure` - The closure to execute.

### addBuildListener

    void addBuildListener(BuildListener buildListener)

  Adds a `BuildListener` to this Build instance. The listener is notified of events which occur during the execution of the build.

  Parameters:
    `buildListener` - The listener to add.

### addListener

    void addListener(Object listener)

  Adds the given listener to this build. The listener may implement any of the given listener interfaces:
  - `BuildListener`
  - `TaskExecutionGraphListener`
  - `ProjectEvaluationListener`
  - `TaskExecutionListener`
  - `TaskActionListener`
  - `StandardOutputListener`
  - `TestListener`

  Parameters:
    `listener` - The listener to add. Does nothing if this listener has already been added.

### removeListener

    void removeListener(Object listener)

  Removes the given listener from this build.

  Parameters:
    `listener` - The listener to remove. Does nothing if this listener has not been added.

### useLogger

    void useLogger(Object logger)

  Uses the given object as a logger. The logger object may implement any of the listener interfaces supported by `addListener(Object)`. Each listener interface has exactly one associated logger. When you call this method with a logger of a given listener type, the new logger will replace whichever logger is currently associated with the listener type. This allows you to selectively replace the standard logging which Gradle provides with your own implementation, for certain types of events.

  Parameters:
    `logger` - The logger to use.

### getGradle

    Gradle getGradle()

  Returns this `Gradle` instance. This method is useful in init scripts to explicitly access Gradle properties and methods. For example, using `gradle.parent` can express your intent better than using `parent`. This property also allows you to access Gradle properties from a scope where the property may be hidden, such as, for example, from a method or closure.

  Returns:
    this. Never returns null.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD